using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.OleDb;
using System.IO;
using System.Text;
using System.Diagnostics;

using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace GroupCustomers
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			//Application.EnableVisualStyles();
			Application.Run(new Form1());
		}

		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem11;
		private System.Windows.Forms.MenuItem menuItemCountryU;
		private System.Windows.Forms.MenuItem menuItem21;
		private System.Windows.Forms.MenuItem menuItemSortCountry;
		private System.Windows.Forms.MenuItem menuItem50;
		private System.Data.SqlClient.SqlCommand sqlSelectCommand1;
		private System.Data.SqlClient.SqlCommand sqlInsertCommand1;
		private System.Data.SqlClient.SqlCommand sqlUpdateCommand1;
		private System.Data.SqlClient.SqlCommand sqlDeleteCommand1;
		private System.Data.SqlClient.SqlConnection sqlConnection1;
		private System.Data.SqlClient.SqlDataAdapter sqlDataAdapter1;
		private GroupCustomers.DataSet1 dataSet11;
		private System.Windows.Forms.MenuItem menuItemDsChoose;
		private System.Windows.Forms.MenuItem menuItemFilterCountryU;
		private System.Windows.Forms.MenuItem menuItemFilterRegionWA;
		private System.Windows.Forms.MenuItem menuItemFilterCityB;
		private System.Windows.Forms.MenuItem menuItemFilterClear;
		private System.Windows.Forms.MenuItem menuItemFilterChoose;
		private System.Windows.Forms.MenuItem menuItemSumCountryDistinct;
		private System.Windows.Forms.MenuItem menuItemSumRecordCount;
		private System.Windows.Forms.MenuItem menuItemSumStringMaxLen;
		private System.Windows.Forms.MenuItem menuItemSumTitleDistinct;
		private System.Windows.Forms.MenuItem menuItemSumClear;
		private System.Windows.Forms.MenuItem menuItemSumChoose;
		private System.Windows.Forms.MenuItem menuItemGroupCountry;
		private System.Windows.Forms.MenuItem menuItemGroupRegion;
		private System.Windows.Forms.MenuItem menuItemGroupCity;
		private System.Windows.Forms.MenuItem menuItemGroupContactTitle;
		private System.Windows.Forms.MenuItem menuItemGroupClear;
		private System.Windows.Forms.MenuItem menuItemGroupChoose;
		private System.Windows.Forms.MenuItem menuItemSortCountry2;
		private System.Windows.Forms.MenuItem menuItemSortRegion;
		private System.Windows.Forms.MenuItem menuItemSortCity;
		private System.Windows.Forms.MenuItem menuItemSortSalesTitle;
		private System.Windows.Forms.MenuItem menuItemSortPostal;
		private System.Windows.Forms.MenuItem menuItemSortClear;
		private System.Windows.Forms.MenuItem menuItemSortChoose;
		private System.Windows.Forms.MenuItem menuItemNavigate;
		private System.Windows.Forms.MenuItem menuItemNavNextRec;
		private System.Windows.Forms.MenuItem menuItemNavPrevRec;
		private System.Windows.Forms.MenuItem menuItemResetColumns;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem menuItem10;
		private System.Windows.Forms.MenuItem menuItemCustomers;
		private System.Windows.Forms.MenuItem menuItemBrowseTable;
		private System.Windows.Forms.MenuItem menuItemXPThemes;
		private System.Windows.Forms.MenuItem menuItemDisplayStyles;
		private System.Windows.Forms.MenuItem menuItemChooseColumnSets;
		private System.Windows.Forms.MenuItem menuItemResetColumnSets;
		private System.Windows.Forms.MenuItem menuItemChooseColumnOrder;
		private System.Windows.Forms.MenuItem menuItemResetColumnOrder;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl groupingGrid1;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItemExpressionColumns;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		void ReadXml(DataSet ds, string xmlFileName)
		{
			for (int n = 0; n < 10; n++)
			{
				if (File.Exists(xmlFileName))
				{
					ds.ReadXml(xmlFileName);
					break;
				}
				xmlFileName = @"..\" + xmlFileName;
			}
		}


		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

//			this.groupingGrid1.ShowNavigationBar = true;
			//this.groupingGrid1.GridGroupDropArea.PrepareViewStyleInfo += new GridPrepareViewStyleInfoEventHandler(GridGroupDropArea_PrepareViewStyleInfo);
			//this.groupingGrid1.GridGroupDropArea.Model.QueryRowHeight += new GridRowColSizeEventHandler(Model_QueryRowHeight);

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			this.groupingGrid1.DataMember = "";
			this.groupingGrid1.DataSource = this.dataSet11.Customers;
			this.groupingGrid1.ShowGroupDropArea = true;
			this.groupingGrid1.FilterRuntimeProperties = true; // don't show all properties in PropertyGrid

			this.groupingGrid1.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(groupingGrid1_QueryCellStyleInfo);
			ReadXml(this.dataSet11, @"Data\GDBDdata.XML");


			GridSummaryRowDescriptor groupCaptionSummaryRow = new GridSummaryRowDescriptor("GroupCaption");
			groupCaptionSummaryRow.Visible = false;
			GridSummaryColumnDescriptor countSummaryColumnDescriptor = new GridSummaryColumnDescriptor("CaptionCount");
			countSummaryColumnDescriptor.SummaryType = SummaryType.Count;
			countSummaryColumnDescriptor.DataMember = "(Record)";
			groupCaptionSummaryRow.SummaryColumns.Add(countSummaryColumnDescriptor);
			this.groupingGrid1.TableDescriptor.SummaryRows.Add(groupCaptionSummaryRow);

			this.groupingGrid1.ChildGroupOptions.CaptionText = "{CategoryName}: {Category} - {RecordCount} Items  CustomSummary={GroupCaption.CaptionCount}";
			this.groupingGrid1.TopLevelGroupOptions.CaptionText = "{TableName}: {RecordCount} Items  CustomSummary={GroupCaption.CaptionCount}";


			this.groupingGrid1.Engine.Appearance.AlternateRecordFieldCell.BackColor = Color.Wheat;

			this.groupingGrid1.TableDescriptor.GroupedColumns.Add("Country");

			
			GridGroup germanyGroup = (GridGroup) this.groupingGrid1.Table.TopLevelGroup.Groups["Germany"];

			int index = this.groupingGrid1.Table.TopLevelGroup.Groups.FindGroup("Germany");
			if (index != -1)
			{
				Group germanyGroup2 = this.groupingGrid1.Table.TopLevelGroup.Groups[index];
				Trace.WriteLine(germanyGroup2);
			}

			this.groupingGrid1.TableDescriptor.ExpressionFields.Add(new ExpressionFieldDescriptor("Expr1", "[PostalCode]"));

			Record r = this.groupingGrid1.Table.Records[0];
			object o = r.GetValue("Expr1");


		}


		int levelOffsetInPixels = 6;
		int maximumLevels = 3; // reserve space for 3 more levels (3*4)

		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad (e);

			int extraHeight = levelOffsetInPixels * maximumLevels;
			this.groupingGrid1.GridGroupDropArea.Model.RowHeights[2] = 18 + extraHeight; 
			this.groupingGrid1.GridGroupDropArea.Height += extraHeight;
			this.groupingGrid1.GridGroupDropArea.Parent.Height += extraHeight;

			this.groupingGrid1.GridGroupDropArea.PrepareViewStyleInfo += new GridPrepareViewStyleInfoEventHandler(GridGroupDropArea_PrepareViewStyleInfo);
		}
		
		private void GridGroupDropArea_PrepareViewStyleInfo(object sender, GridPrepareViewStyleInfoEventArgs e)
		{
			GridGroupDropArea grid = (GridGroupDropArea) sender;
			TableDescriptor td = grid.Model.GridTableModel.Table.TableDescriptor;
			if (e.RowIndex == 2)
			{
				int extraHeight = levelOffsetInPixels * maximumLevels;
				int groupedColumn = grid.Model.ColIndexToField(e.ColIndex);
				int offset = Math.Min(maximumLevels-1, groupedColumn) * levelOffsetInPixels;  
				e.Style.BorderMargins.Top = offset;
				e.Style.BorderMargins.Bottom = extraHeight - offset;
				e.Style.BackColor = grid.Model.TableStyle.BackColor;
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dataSet11 = new GroupCustomers.DataSet1();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItemCustomers = new System.Windows.Forms.MenuItem();
			this.menuItemBrowseTable = new System.Windows.Forms.MenuItem();
			this.menuItem10 = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItemDsChoose = new System.Windows.Forms.MenuItem();
			this.menuItemResetColumns = new System.Windows.Forms.MenuItem();
			this.menuItemChooseColumnSets = new System.Windows.Forms.MenuItem();
			this.menuItemResetColumnSets = new System.Windows.Forms.MenuItem();
			this.menuItemChooseColumnOrder = new System.Windows.Forms.MenuItem();
			this.menuItemResetColumnOrder = new System.Windows.Forms.MenuItem();
			this.menuItemFilterCountryU = new System.Windows.Forms.MenuItem();
			this.menuItemCountryU = new System.Windows.Forms.MenuItem();
			this.menuItemFilterRegionWA = new System.Windows.Forms.MenuItem();
			this.menuItemFilterCityB = new System.Windows.Forms.MenuItem();
			this.menuItemFilterClear = new System.Windows.Forms.MenuItem();
			this.menuItemFilterChoose = new System.Windows.Forms.MenuItem();
			this.menuItem21 = new System.Windows.Forms.MenuItem();
			this.menuItemGroupCountry = new System.Windows.Forms.MenuItem();
			this.menuItemGroupRegion = new System.Windows.Forms.MenuItem();
			this.menuItemGroupCity = new System.Windows.Forms.MenuItem();
			this.menuItemGroupContactTitle = new System.Windows.Forms.MenuItem();
			this.menuItemGroupClear = new System.Windows.Forms.MenuItem();
			this.menuItemGroupChoose = new System.Windows.Forms.MenuItem();
			this.menuItem11 = new System.Windows.Forms.MenuItem();
			this.menuItemSumCountryDistinct = new System.Windows.Forms.MenuItem();
			this.menuItemSumRecordCount = new System.Windows.Forms.MenuItem();
			this.menuItemSumStringMaxLen = new System.Windows.Forms.MenuItem();
			this.menuItemSumTitleDistinct = new System.Windows.Forms.MenuItem();
			this.menuItemSumClear = new System.Windows.Forms.MenuItem();
			this.menuItemSumChoose = new System.Windows.Forms.MenuItem();
			this.menuItemSortCountry = new System.Windows.Forms.MenuItem();
			this.menuItemSortCountry2 = new System.Windows.Forms.MenuItem();
			this.menuItemSortRegion = new System.Windows.Forms.MenuItem();
			this.menuItemSortCity = new System.Windows.Forms.MenuItem();
			this.menuItemSortSalesTitle = new System.Windows.Forms.MenuItem();
			this.menuItemSortPostal = new System.Windows.Forms.MenuItem();
			this.menuItemSortClear = new System.Windows.Forms.MenuItem();
			this.menuItemSortChoose = new System.Windows.Forms.MenuItem();
			this.menuItemNavigate = new System.Windows.Forms.MenuItem();
			this.menuItemNavNextRec = new System.Windows.Forms.MenuItem();
			this.menuItemNavPrevRec = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.menuItemXPThemes = new System.Windows.Forms.MenuItem();
			this.menuItemDisplayStyles = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem50 = new System.Windows.Forms.MenuItem();
			this.sqlSelectCommand1 = new System.Data.SqlClient.SqlCommand();
			this.sqlConnection1 = new System.Data.SqlClient.SqlConnection();
			this.sqlInsertCommand1 = new System.Data.SqlClient.SqlCommand();
			this.sqlUpdateCommand1 = new System.Data.SqlClient.SqlCommand();
			this.sqlDeleteCommand1 = new System.Data.SqlClient.SqlCommand();
			this.sqlDataAdapter1 = new System.Data.SqlClient.SqlDataAdapter();
			this.groupingGrid1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.menuItemExpressionColumns = new System.Windows.Forms.MenuItem();
			((System.ComponentModel.ISupportInitialize)(this.dataSet11)).BeginInit();
			this.SuspendLayout();
			// 
			// dataSet11
			// 
			this.dataSet11.DataSetName = "DataSet1";
			this.dataSet11.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem2,
																					  this.menuItem1,
																					  this.menuItem5,
																					  this.menuItemFilterCountryU,
																					  this.menuItem21,
																					  this.menuItem11,
																					  this.menuItemSortCountry,
																					  this.menuItemNavigate,
																					  this.menuItem7});
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 0;
			this.menuItem2.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem4,
																					  this.menuItem10});
			this.menuItem2.Text = "File";
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 0;
			this.menuItem4.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItemCustomers,
																					  this.menuItemBrowseTable});
			this.menuItem4.Text = "Open";
			// 
			// menuItemCustomers
			// 
			this.menuItemCustomers.Index = 0;
			this.menuItemCustomers.Text = "CustomersDataTable (from Xml)";
			this.menuItemCustomers.Click += new System.EventHandler(this.menuItemCustomers_Click);
			// 
			// menuItemBrowseTable
			// 
			this.menuItemBrowseTable.Index = 1;
			this.menuItemBrowseTable.Text = "Browse Table";
			this.menuItemBrowseTable.Click += new System.EventHandler(this.menuItemBrowseTable_Click);
			// 
			// menuItem10
			// 
			this.menuItem10.Index = 1;
			this.menuItem10.Text = "Reset Filters, Summaries and Grouping";
			this.menuItem10.Click += new System.EventHandler(this.menuItem10_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 1;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItemDsChoose,
																					  this.menuItemResetColumns,
																					  this.menuItemChooseColumnSets,
																					  this.menuItemResetColumnSets,
																					  this.menuItemChooseColumnOrder,
																					  this.menuItemResetColumnOrder});
			this.menuItem1.Text = "Columns";
			// 
			// menuItemDsChoose
			// 
			this.menuItemDsChoose.Index = 0;
			this.menuItemDsChoose.Text = "Choose Columns ..";
			this.menuItemDsChoose.Click += new System.EventHandler(this.menuItemDsChoose_Click);
			// 
			// menuItemResetColumns
			// 
			this.menuItemResetColumns.Index = 1;
			this.menuItemResetColumns.Text = "Reset Columns";
			this.menuItemResetColumns.Click += new System.EventHandler(this.menuItemResetColumns_Click);
			// 
			// menuItemChooseColumnSets
			// 
			this.menuItemChooseColumnSets.Index = 2;
			this.menuItemChooseColumnSets.Text = "Choose ColumnSets ..";
			this.menuItemChooseColumnSets.Click += new System.EventHandler(this.menuItemChooseColumnSets_Click);
			// 
			// menuItemResetColumnSets
			// 
			this.menuItemResetColumnSets.Index = 3;
			this.menuItemResetColumnSets.Text = "Reset ColumnSets";
			this.menuItemResetColumnSets.Click += new System.EventHandler(this.menuItemResetColumnSets_Click);
			// 
			// menuItemChooseColumnOrder
			// 
			this.menuItemChooseColumnOrder.Index = 4;
			this.menuItemChooseColumnOrder.Text = "Choose Column Order ..";
			this.menuItemChooseColumnOrder.Click += new System.EventHandler(this.menuItemChooseColumnOrder_Click);
			// 
			// menuItemResetColumnOrder
			// 
			this.menuItemResetColumnOrder.Index = 5;
			this.menuItemResetColumnOrder.Text = "Reset Column Order ";
			this.menuItemResetColumnOrder.Click += new System.EventHandler(this.menuItemResetColumnOrder_Click);
			// 
			// menuItemFilterCountryU
			// 
			this.menuItemFilterCountryU.Index = 3;
			this.menuItemFilterCountryU.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																								   this.menuItemCountryU,
																								   this.menuItemFilterRegionWA,
																								   this.menuItemFilterCityB,
																								   this.menuItemFilterClear,
																								   this.menuItemFilterChoose});
			this.menuItemFilterCountryU.Text = "Filter";
			// 
			// menuItemCountryU
			// 
			this.menuItemCountryU.Index = 0;
			this.menuItemCountryU.Text = "Country like \"U*\"";
			this.menuItemCountryU.Click += new System.EventHandler(this.menuItemCountryU_Click);
			// 
			// menuItemFilterRegionWA
			// 
			this.menuItemFilterRegionWA.Index = 1;
			this.menuItemFilterRegionWA.Text = "Region = \"WA\"";
			this.menuItemFilterRegionWA.Click += new System.EventHandler(this.menuItemFilterRegionWA_Click);
			// 
			// menuItemFilterCityB
			// 
			this.menuItemFilterCityB.Index = 2;
			this.menuItemFilterCityB.Text = "City like \"B*\"";
			this.menuItemFilterCityB.Click += new System.EventHandler(this.menuItemFilterCityB_Click);
			// 
			// menuItemFilterClear
			// 
			this.menuItemFilterClear.Index = 3;
			this.menuItemFilterClear.Text = "Clear Filters";
			this.menuItemFilterClear.Click += new System.EventHandler(this.menuItemFilterClear_Click);
			// 
			// menuItemFilterChoose
			// 
			this.menuItemFilterChoose.Index = 4;
			this.menuItemFilterChoose.Text = "Choose Filters ..";
			this.menuItemFilterChoose.Click += new System.EventHandler(this.menuItemFilterChoose_Click);
			// 
			// menuItem21
			// 
			this.menuItem21.Index = 4;
			this.menuItem21.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.menuItemGroupCountry,
																					   this.menuItemGroupRegion,
																					   this.menuItemGroupCity,
																					   this.menuItemGroupContactTitle,
																					   this.menuItemGroupClear,
																					   this.menuItemGroupChoose});
			this.menuItem21.Text = "Grouping";
			// 
			// menuItemGroupCountry
			// 
			this.menuItemGroupCountry.Index = 0;
			this.menuItemGroupCountry.Text = "Add Country";
			this.menuItemGroupCountry.Click += new System.EventHandler(this.menuItemGroupCountry_Click);
			// 
			// menuItemGroupRegion
			// 
			this.menuItemGroupRegion.Index = 1;
			this.menuItemGroupRegion.Text = "Add Region";
			this.menuItemGroupRegion.Click += new System.EventHandler(this.menuItemGroupRegion_Click);
			// 
			// menuItemGroupCity
			// 
			this.menuItemGroupCity.Index = 2;
			this.menuItemGroupCity.Text = "Add City";
			this.menuItemGroupCity.Click += new System.EventHandler(this.menuItemGroupCity_Click);
			// 
			// menuItemGroupContactTitle
			// 
			this.menuItemGroupContactTitle.Index = 3;
			this.menuItemGroupContactTitle.Text = "Add ContactTitle";
			this.menuItemGroupContactTitle.Click += new System.EventHandler(this.menuItemGroupContactTitle_Click);
			// 
			// menuItemGroupClear
			// 
			this.menuItemGroupClear.Index = 4;
			this.menuItemGroupClear.Text = "Clear Grouping";
			this.menuItemGroupClear.Click += new System.EventHandler(this.menuItemGroupClear_Click);
			// 
			// menuItemGroupChoose
			// 
			this.menuItemGroupChoose.Index = 5;
			this.menuItemGroupChoose.Text = "Choose Grouping ..";
			this.menuItemGroupChoose.Click += new System.EventHandler(this.menuItemGroupChoose_Click);
			// 
			// menuItem11
			// 
			this.menuItem11.Index = 5;
			this.menuItem11.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.menuItemSumCountryDistinct,
																					   this.menuItemSumRecordCount,
																					   this.menuItemSumStringMaxLen,
																					   this.menuItemSumTitleDistinct,
																					   this.menuItemSumClear,
																					   this.menuItemSumChoose});
			this.menuItem11.Text = "Summaries";
			// 
			// menuItemSumCountryDistinct
			// 
			this.menuItemSumCountryDistinct.Index = 0;
			this.menuItemSumCountryDistinct.Text = "Add Distinct Count of Country";
			this.menuItemSumCountryDistinct.Click += new System.EventHandler(this.menuItemSumCountryDistinct_Click);
			// 
			// menuItemSumRecordCount
			// 
			this.menuItemSumRecordCount.Index = 1;
			this.menuItemSumRecordCount.Text = "Add Record Count";
			this.menuItemSumRecordCount.Click += new System.EventHandler(this.menuItemSumRecordCount_Click);
			// 
			// menuItemSumStringMaxLen
			// 
			this.menuItemSumStringMaxLen.Index = 2;
			this.menuItemSumStringMaxLen.Text = "Add String Maximum Length";
			this.menuItemSumStringMaxLen.Click += new System.EventHandler(this.menuItemSumStringMaxLen_Click);
			// 
			// menuItemSumTitleDistinct
			// 
			this.menuItemSumTitleDistinct.Index = 3;
			this.menuItemSumTitleDistinct.Text = "Add Distinct Count Title";
			this.menuItemSumTitleDistinct.Click += new System.EventHandler(this.menuItemSumTitleDistinct_Click);
			// 
			// menuItemSumClear
			// 
			this.menuItemSumClear.Index = 4;
			this.menuItemSumClear.Text = "Clear Summaries";
			this.menuItemSumClear.Click += new System.EventHandler(this.menuItemSumClear_Click);
			// 
			// menuItemSumChoose
			// 
			this.menuItemSumChoose.Index = 5;
			this.menuItemSumChoose.Text = "Choose Summaries ..";
			this.menuItemSumChoose.Click += new System.EventHandler(this.menuItemSumChoose_Click);
			// 
			// menuItemSortCountry
			// 
			this.menuItemSortCountry.Index = 6;
			this.menuItemSortCountry.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																								this.menuItemSortCountry2,
																								this.menuItemSortRegion,
																								this.menuItemSortCity,
																								this.menuItemSortSalesTitle,
																								this.menuItemSortPostal,
																								this.menuItemSortClear,
																								this.menuItemSortChoose});
			this.menuItemSortCountry.Text = "Sorting";
			// 
			// menuItemSortCountry2
			// 
			this.menuItemSortCountry2.Index = 0;
			this.menuItemSortCountry2.Text = "Sort Country";
			this.menuItemSortCountry2.Click += new System.EventHandler(this.menuItemSortCountry2_Click);
			// 
			// menuItemSortRegion
			// 
			this.menuItemSortRegion.Index = 1;
			this.menuItemSortRegion.Text = "Sort Region";
			this.menuItemSortRegion.Click += new System.EventHandler(this.menuItemSortRegion_Click);
			// 
			// menuItemSortCity
			// 
			this.menuItemSortCity.Index = 2;
			this.menuItemSortCity.Text = "Sort City";
			this.menuItemSortCity.Click += new System.EventHandler(this.menuItemSortCity_Click);
			// 
			// menuItemSortSalesTitle
			// 
			this.menuItemSortSalesTitle.Index = 3;
			this.menuItemSortSalesTitle.Text = "Sort SalesTitle";
			this.menuItemSortSalesTitle.Click += new System.EventHandler(this.menuItemSortSalesTitle_Click);
			// 
			// menuItemSortPostal
			// 
			this.menuItemSortPostal.Index = 4;
			this.menuItemSortPostal.Text = "Sort PostalCode";
			this.menuItemSortPostal.Click += new System.EventHandler(this.menuItemSortPostal_Click);
			// 
			// menuItemSortClear
			// 
			this.menuItemSortClear.Index = 5;
			this.menuItemSortClear.Text = "Clear Sorting";
			this.menuItemSortClear.Click += new System.EventHandler(this.menuItemSortClear_Click);
			// 
			// menuItemSortChoose
			// 
			this.menuItemSortChoose.Index = 6;
			this.menuItemSortChoose.Text = "Choose Sorting ..";
			this.menuItemSortChoose.Click += new System.EventHandler(this.menuItemSortChoose_Click);
			// 
			// menuItemNavigate
			// 
			this.menuItemNavigate.Index = 7;
			this.menuItemNavigate.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							 this.menuItemNavNextRec,
																							 this.menuItemNavPrevRec});
			this.menuItemNavigate.Text = "Navigate";
			// 
			// menuItemNavNextRec
			// 
			this.menuItemNavNextRec.Index = 0;
			this.menuItemNavNextRec.Text = "Next Record";
			this.menuItemNavNextRec.Click += new System.EventHandler(this.menuItemNavNextRec_Click);
			// 
			// menuItemNavPrevRec
			// 
			this.menuItemNavPrevRec.Index = 1;
			this.menuItemNavPrevRec.Text = "Previous Record";
			this.menuItemNavPrevRec.Click += new System.EventHandler(this.menuItemNavPrevRec_Click);
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 8;
			this.menuItem7.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItemXPThemes,
																					  this.menuItemDisplayStyles});
			this.menuItem7.Text = "Options";
			// 
			// menuItemXPThemes
			// 
			this.menuItemXPThemes.Index = 0;
			this.menuItemXPThemes.Text = "Enable/Disable XP Themes..";
			this.menuItemXPThemes.Click += new System.EventHandler(this.menuItemXPThemes_Click);
			// 
			// menuItemDisplayStyles
			// 
			this.menuItemDisplayStyles.Index = 1;
			this.menuItemDisplayStyles.Text = "Display Styles ..";
			this.menuItemDisplayStyles.Click += new System.EventHandler(this.menuItemDisplayStyles_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = -1;
			this.menuItem3.Text = "";
			// 
			// menuItem50
			// 
			this.menuItem50.Index = -1;
			this.menuItem50.Text = "";
			// 
			// sqlSelectCommand1
			// 
			this.sqlSelectCommand1.CommandText = "SELECT CustomerID, CompanyName, ContactName, ContactTitle, Address, City, Region," +
				" PostalCode, Country, Phone, Fax FROM Customers";
			this.sqlSelectCommand1.Connection = this.sqlConnection1;
			// 
			// sqlConnection1
			// 
			this.sqlConnection1.ConnectionString = "data source=(local)\\NETSDK;initial catalog=Northwind;integrated security=SSPI;per" +
				"sist security info=True;workstation id=localhost;packet size=4096";
			// 
			// sqlInsertCommand1
			// 
			this.sqlInsertCommand1.CommandText = @"INSERT INTO Customers(CustomerID, CompanyName, ContactName, ContactTitle, Address, City, Region, PostalCode, Country, Phone, Fax) VALUES (@CustomerID, @CompanyName, @ContactName, @ContactTitle, @Address, @City, @Region, @PostalCode, @Country, @Phone, @Fax); SELECT CustomerID, CompanyName, ContactName, ContactTitle, Address, City, Region, PostalCode, Country, Phone, Fax FROM Customers WHERE (CustomerID = @CustomerID)";
			this.sqlInsertCommand1.Connection = this.sqlConnection1;
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@CustomerID", System.Data.SqlDbType.NVarChar, 5, "CustomerID"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@CompanyName", System.Data.SqlDbType.NVarChar, 40, "CompanyName"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ContactName", System.Data.SqlDbType.NVarChar, 30, "ContactName"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ContactTitle", System.Data.SqlDbType.NVarChar, 30, "ContactTitle"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Address", System.Data.SqlDbType.NVarChar, 60, "Address"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@City", System.Data.SqlDbType.NVarChar, 15, "City"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Region", System.Data.SqlDbType.NVarChar, 15, "Region"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@PostalCode", System.Data.SqlDbType.NVarChar, 10, "PostalCode"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Country", System.Data.SqlDbType.NVarChar, 15, "Country"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Phone", System.Data.SqlDbType.NVarChar, 24, "Phone"));
			this.sqlInsertCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Fax", System.Data.SqlDbType.NVarChar, 24, "Fax"));
			// 
			// sqlUpdateCommand1
			// 
			this.sqlUpdateCommand1.CommandText = @"UPDATE Customers SET CustomerID = @CustomerID, CompanyName = @CompanyName, ContactName = @ContactName, ContactTitle = @ContactTitle, Address = @Address, City = @City, Region = @Region, PostalCode = @PostalCode, Country = @Country, Phone = @Phone, Fax = @Fax WHERE (CustomerID = @Original_CustomerID) AND (Address = @Original_Address OR @Original_Address IS NULL AND Address IS NULL) AND (City = @Original_City OR @Original_City IS NULL AND City IS NULL) AND (CompanyName = @Original_CompanyName) AND (ContactName = @Original_ContactName OR @Original_ContactName IS NULL AND ContactName IS NULL) AND (ContactTitle = @Original_ContactTitle OR @Original_ContactTitle IS NULL AND ContactTitle IS NULL) AND (Country = @Original_Country OR @Original_Country IS NULL AND Country IS NULL) AND (Fax = @Original_Fax OR @Original_Fax IS NULL AND Fax IS NULL) AND (Phone = @Original_Phone OR @Original_Phone IS NULL AND Phone IS NULL) AND (PostalCode = @Original_PostalCode OR @Original_PostalCode IS NULL AND PostalCode IS NULL) AND (Region = @Original_Region OR @Original_Region IS NULL AND Region IS NULL); SELECT CustomerID, CompanyName, ContactName, ContactTitle, Address, City, Region, PostalCode, Country, Phone, Fax FROM Customers WHERE (CustomerID = @CustomerID)";
			this.sqlUpdateCommand1.Connection = this.sqlConnection1;
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@CustomerID", System.Data.SqlDbType.NVarChar, 5, "CustomerID"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@CompanyName", System.Data.SqlDbType.NVarChar, 40, "CompanyName"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ContactName", System.Data.SqlDbType.NVarChar, 30, "ContactName"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@ContactTitle", System.Data.SqlDbType.NVarChar, 30, "ContactTitle"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Address", System.Data.SqlDbType.NVarChar, 60, "Address"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@City", System.Data.SqlDbType.NVarChar, 15, "City"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Region", System.Data.SqlDbType.NVarChar, 15, "Region"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@PostalCode", System.Data.SqlDbType.NVarChar, 10, "PostalCode"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Country", System.Data.SqlDbType.NVarChar, 15, "Country"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Phone", System.Data.SqlDbType.NVarChar, 24, "Phone"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Fax", System.Data.SqlDbType.NVarChar, 24, "Fax"));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_CustomerID", System.Data.SqlDbType.NVarChar, 5, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "CustomerID", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Address", System.Data.SqlDbType.NVarChar, 60, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Address", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_City", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "City", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_CompanyName", System.Data.SqlDbType.NVarChar, 40, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "CompanyName", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ContactName", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ContactName", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ContactTitle", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ContactTitle", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Country", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Country", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Fax", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Fax", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Phone", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Phone", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_PostalCode", System.Data.SqlDbType.NVarChar, 10, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "PostalCode", System.Data.DataRowVersion.Original, null));
			this.sqlUpdateCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Region", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Region", System.Data.DataRowVersion.Original, null));
			// 
			// sqlDeleteCommand1
			// 
			this.sqlDeleteCommand1.CommandText = @"DELETE FROM Customers WHERE (CustomerID = @Original_CustomerID) AND (Address = @Original_Address OR @Original_Address IS NULL AND Address IS NULL) AND (City = @Original_City OR @Original_City IS NULL AND City IS NULL) AND (CompanyName = @Original_CompanyName) AND (ContactName = @Original_ContactName OR @Original_ContactName IS NULL AND ContactName IS NULL) AND (ContactTitle = @Original_ContactTitle OR @Original_ContactTitle IS NULL AND ContactTitle IS NULL) AND (Country = @Original_Country OR @Original_Country IS NULL AND Country IS NULL) AND (Fax = @Original_Fax OR @Original_Fax IS NULL AND Fax IS NULL) AND (Phone = @Original_Phone OR @Original_Phone IS NULL AND Phone IS NULL) AND (PostalCode = @Original_PostalCode OR @Original_PostalCode IS NULL AND PostalCode IS NULL) AND (Region = @Original_Region OR @Original_Region IS NULL AND Region IS NULL)";
			this.sqlDeleteCommand1.Connection = this.sqlConnection1;
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_CustomerID", System.Data.SqlDbType.NVarChar, 5, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "CustomerID", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Address", System.Data.SqlDbType.NVarChar, 60, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Address", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_City", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "City", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_CompanyName", System.Data.SqlDbType.NVarChar, 40, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "CompanyName", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ContactName", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ContactName", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_ContactTitle", System.Data.SqlDbType.NVarChar, 30, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ContactTitle", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Country", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Country", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Fax", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Fax", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Phone", System.Data.SqlDbType.NVarChar, 24, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Phone", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_PostalCode", System.Data.SqlDbType.NVarChar, 10, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "PostalCode", System.Data.DataRowVersion.Original, null));
			this.sqlDeleteCommand1.Parameters.Add(new System.Data.SqlClient.SqlParameter("@Original_Region", System.Data.SqlDbType.NVarChar, 15, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Region", System.Data.DataRowVersion.Original, null));
			// 
			// sqlDataAdapter1
			// 
			this.sqlDataAdapter1.DeleteCommand = this.sqlDeleteCommand1;
			this.sqlDataAdapter1.InsertCommand = this.sqlInsertCommand1;
			this.sqlDataAdapter1.SelectCommand = this.sqlSelectCommand1;
			this.sqlDataAdapter1.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																									  new System.Data.Common.DataTableMapping("Table", "Customers", new System.Data.Common.DataColumnMapping[] {
																																																				   new System.Data.Common.DataColumnMapping("CustomerID", "CustomerID"),
																																																				   new System.Data.Common.DataColumnMapping("CompanyName", "CompanyName"),
																																																				   new System.Data.Common.DataColumnMapping("ContactName", "ContactName"),
																																																				   new System.Data.Common.DataColumnMapping("ContactTitle", "ContactTitle"),
																																																				   new System.Data.Common.DataColumnMapping("Address", "Address"),
																																																				   new System.Data.Common.DataColumnMapping("City", "City"),
																																																				   new System.Data.Common.DataColumnMapping("Region", "Region"),
																																																				   new System.Data.Common.DataColumnMapping("PostalCode", "PostalCode"),
																																																				   new System.Data.Common.DataColumnMapping("Country", "Country"),
																																																				   new System.Data.Common.DataColumnMapping("Phone", "Phone"),
																																																				   new System.Data.Common.DataColumnMapping("Fax", "Fax")})});
			this.sqlDataAdapter1.UpdateCommand = this.sqlUpdateCommand1;
			// 
			// groupingGrid1
			// 
			this.groupingGrid1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.groupingGrid1.Location = new System.Drawing.Point(0, 0);
			this.groupingGrid1.Name = "groupingGrid1";
			this.groupingGrid1.ShowNavigationBar = true;
			this.groupingGrid1.Size = new System.Drawing.Size(688, 353);
			this.groupingGrid1.TabIndex = 1;
			this.groupingGrid1.Text = "groupingGrid1";
			this.groupingGrid1.ThemesEnabled = true;
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 2;
			this.menuItem5.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItemExpressionColumns});
			this.menuItem5.Text = "Expressions";
			// 
			// menuItemExpressionColumns
			// 
			this.menuItemExpressionColumns.Index = 0;
			this.menuItemExpressionColumns.Text = "Choose Expression Columns ...";
			this.menuItemExpressionColumns.Click += new System.EventHandler(this.menuItemExpressionColumns_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(688, 353);
			this.Controls.Add(this.groupingGrid1);
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.dataSet11)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion


		private void menuItemExitApp_Click(object sender, System.EventArgs e)
		{
			Application.Exit();
		}

		private void menuItemDsChoose_Click(object sender, System.EventArgs e)
		{
			_ShowGridColumnsDialog(this.groupingGrid1.Engine.TableDescriptor, "Columns", null, typeof(GridColumnDescriptorCollection));
		}
		
		internal DialogResult _ShowGridBaseStylesDialog(object instance, string propertyName, IServiceProvider provider, Type type)
		{
			System.ComponentModel.Design.CollectionEditor ce = new System.ComponentModel.Design.CollectionEditor(type);
			Syncfusion.ComponentModel.WindowsFormsEditorServiceContainer esc = new Syncfusion.ComponentModel.WindowsFormsEditorServiceContainer(provider);
			PropertyDescriptor pd = TypeDescriptor.GetProperties(instance)[propertyName];
			Syncfusion.ComponentModel.TypeDescriptorContext tdc = new Syncfusion.ComponentModel.TypeDescriptorContext(instance, pd);
			tdc.ServiceProvider = esc;

			ce.EditValue(tdc, esc, pd.GetValue(instance));

			return esc.DialogResult;
		}

		internal DialogResult _ShowGridColumnsDialog(object instance, string propertyName, IServiceProvider provider, Type type)
		{
			GroupingCollectionEditor ce = new GroupingCollectionEditor(type);
			Syncfusion.ComponentModel.WindowsFormsEditorServiceContainer esc = new Syncfusion.ComponentModel.WindowsFormsEditorServiceContainer(provider);
			PropertyDescriptor pd = TypeDescriptor.GetProperties(instance)[propertyName];
			Syncfusion.ComponentModel.TypeDescriptorContext tdc = new Syncfusion.ComponentModel.TypeDescriptorContext(instance, pd);
			tdc.ServiceProvider = esc;

			ce.EditValue(tdc, esc, pd.GetValue(instance));

			return esc.DialogResult;
		}

		private void menuItemFilterChoose_Click(object sender, System.EventArgs e)
		{
			_ShowGridColumnsDialog(this.groupingGrid1.Engine.TableDescriptor, "RecordFilters", null, typeof(RecordFilterDescriptorCollection));
		}

		private void menuItemSumChoose_Click(object sender, System.EventArgs e)
		{
			//_ShowGridColumnsDialog(this.groupingGrid1.Engine.TableDescriptor, "SummaryColumns", null, typeof(SummaryDescriptorCollection));
			_ShowGridColumnsDialog(this.groupingGrid1.Engine.TableDescriptor, "SummaryRows", null, typeof(GridSummaryRowDescriptorCollection));
		
		}

		private void menuItemGroupChoose_Click(object sender, System.EventArgs e)
		{
			_ShowGridColumnsDialog(this.groupingGrid1.Engine.TableDescriptor, "GroupedColumns", null, typeof(SortColumnDescriptorCollection));
		
		}

		private void menuItemSortChoose_Click(object sender, System.EventArgs e)
		{
			_ShowGridColumnsDialog(this.groupingGrid1.Engine.TableDescriptor, "SortedColumns", null, typeof(SortColumnDescriptorCollection));
		
		}

		private void menuItemDs1_Click(object sender, System.EventArgs e)
		{
		}

		void ReadXml(string xmlFileName)
		{
			string fileName = xmlFileName;
			for (int n = 0; n < 10; n++)
			{
				if (File.Exists(xmlFileName))
				{
					this.dataSet11.ReadXml(xmlFileName);
					return;
				}
				xmlFileName = @".\" + xmlFileName;
			}
			MessageBox.Show(fileName + " not found. \n\nPlease make sure the Grid\\Samples\\Data folder can be found in a parent directory!", "GroupingPreview - Data folder not found");
			Close();
		}

		private void menuItemDsReset_Click(object sender, System.EventArgs e)
		{
			this.groupingGrid1.ResetTableDescriptor();
		}

		private void menuItemSumCountryDistinct_Click(object sender, EventArgs e)
		{
			GridSummaryRowDescriptor sd = null;
			if (this.groupingGrid1.Engine.TableDescriptor.SummaryRows.Contains("DistinctCount"))
				sd = this.groupingGrid1.Engine.TableDescriptor.SummaryRows["DistinctCount"];
			else
				this.groupingGrid1.Engine.TableDescriptor.SummaryRows.Add(sd = new GridSummaryRowDescriptor("DistinctCount"));

			if (!sd.SummaryColumns.Contains("Country"))
			{
				sd.Title = "Distinct";
				GridSummaryColumnDescriptor column = new GridSummaryColumnDescriptor("Country");
				column.SummaryType = SummaryType.DistinctCount;
				column.Style = GridSummaryStyle.Column;
				column.DataMember = "Country";
				column.Format = "Count: {Count}";
				sd.SummaryColumns.Add(column);
			}
		}

		private void menuItemCountryU_Click(object sender, System.EventArgs e)
		{
			this.groupingGrid1.Engine.TableDescriptor.RecordFilters.Add("Country", FilterCompareOperator.Like, "U*");
		}

		private void menuItemFilterRegionWA_Click(object sender, System.EventArgs e)
		{
			this.groupingGrid1.Engine.TableDescriptor.RecordFilters.Add("Region", FilterCompareOperator.Equals, "WA");
		}

		private void menuItemFilterCityB_Click(object sender, System.EventArgs e)
		{
			this.groupingGrid1.Engine.TableDescriptor.RecordFilters.Add("City", FilterCompareOperator.Like, "B*");
		}

		private void menuItemFilterClear_Click(object sender, System.EventArgs e)
		{
			this.groupingGrid1.Engine.TableDescriptor.ResetRecordFilters();
		}

		private void menuItemSumRecordCount_Click(object sender, System.EventArgs e)
		{
			GridSummaryRowDescriptor sd = null;
			if (this.groupingGrid1.Engine.TableDescriptor.SummaryRows.Contains("RecordCount"))
				sd = this.groupingGrid1.Engine.TableDescriptor.SummaryRows["RecordCount"];
			else
				this.groupingGrid1.Engine.TableDescriptor.SummaryRows.Add(sd = new GridSummaryRowDescriptor("RecordCount"));

			sd.Title = "Record Count";
			
			GridSummaryColumnDescriptor column = new GridSummaryColumnDescriptor();
			column.SummaryType = SummaryType.Count;
			column.Style = GridSummaryStyle.FillRow;
			column.DataMember = "(Record)";
			column.Format = "      {Count} Records.";
			sd.SummaryColumns.Add(column);
		}

		private void menuItemSumStringMaxLen_Click(object sender, System.EventArgs e)
		{
			GridSummaryRowDescriptor sd = null;
			if (this.groupingGrid1.Engine.TableDescriptor.SummaryRows.Contains("MaxLen"))
				sd = this.groupingGrid1.Engine.TableDescriptor.SummaryRows["MaxLen"];
			else
				this.groupingGrid1.Engine.TableDescriptor.SummaryRows.Add(sd = new GridSummaryRowDescriptor("MaxLen"));

			sd.Title = "Max Length";
			
			GridSummaryColumnDescriptor column = new GridSummaryColumnDescriptor("CompanyName");
			column.SummaryType = SummaryType.MaxLength;
			column.Style = GridSummaryStyle.Column;
			column.Format = "   {MaxLength} chars.";
			sd.SummaryColumns.Add(column);
			
			column = new GridSummaryColumnDescriptor("City");
			column.SummaryType = SummaryType.MaxLength;
			column.Style = GridSummaryStyle.Column;
			column.Format = "   {MaxLength} chars.";
			sd.SummaryColumns.Add(column);
		}

		private void menuItemSumTitleDistinct_Click(object sender, System.EventArgs e)
		{

			GridSummaryRowDescriptor sd = null;
			if (this.groupingGrid1.Engine.TableDescriptor.SummaryRows.Contains("DistinctCount"))
				sd = this.groupingGrid1.Engine.TableDescriptor.SummaryRows["DistinctCount"];
			else
				this.groupingGrid1.Engine.TableDescriptor.SummaryRows.Add(sd = new GridSummaryRowDescriptor("DistinctCount"));

			sd.Title = "Distinct Count";
			
			if (!sd.SummaryColumns.Contains("ContactTitle"))
			{
				sd.Title = "Distinct";
				GridSummaryColumnDescriptor column = new GridSummaryColumnDescriptor("ContactTitle");
				column.SummaryType = SummaryType.DistinctCount;
				column.Style = GridSummaryStyle.Column;
				column.DataMember = "ContactTitle";
				column.Format = "Count: {Count}";
				sd.SummaryColumns.Add(column);
			}			
		}

		private void menuItemSumClear_Click(object sender, System.EventArgs e)
		{
			this.groupingGrid1.Engine.TableDescriptor.ResetSummaryRows();
		}

		bool IsCustomersTableShown()
		{
			return this.groupingGrid1.Engine.DataMember == "Customers" || this.groupingGrid1.Engine.DataMember == "";
		}

		bool IsCustomersTableShown(bool showMessage)
		{
			bool b = IsCustomersTableShown();
			if (!b && showMessage)
				MessageBox.Show("This menu entry only works with the Customers table. \nUse the 'Choose ..' entry below instead.");
			return b;
		}

		private void menuItemGroupCountry_Click(object sender, System.EventArgs e)
		{
			if (!IsCustomersTableShown(true))
				return;

			this.groupingGrid1.Engine.TableDescriptor.GroupedColumns.Add("Country", ListSortDirection.Ascending);
		}

		private void menuItemGroupRegion_Click(object sender, System.EventArgs e)
		{
			if (!IsCustomersTableShown(true))
				return;

			this.groupingGrid1.Engine.TableDescriptor.GroupedColumns.Add("Region", ListSortDirection.Ascending);
		}

		private void menuItemGroupCity_Click(object sender, System.EventArgs e)
		{
			if (!IsCustomersTableShown(true))
				return;

			this.groupingGrid1.Engine.TableDescriptor.GroupedColumns.Add("City", ListSortDirection.Ascending);

		}

		private void menuItemGroupContactTitle_Click(object sender, System.EventArgs e)
		{
			if (!IsCustomersTableShown(true))
				return;

			this.groupingGrid1.Engine.TableDescriptor.GroupedColumns.Add("ContactTitle", ListSortDirection.Ascending);
		}

		private void menuItemGroupClear_Click(object sender, System.EventArgs e)
		{
			this.groupingGrid1.Engine.TableDescriptor.ResetGroupedColumns();
		}

		private void menuItemSortCountry2_Click(object sender, System.EventArgs e)
		{
			if (!IsCustomersTableShown(true))
				return;

			this.groupingGrid1.Engine.TableDescriptor.SortedColumns.Add("Country", ListSortDirection.Ascending);
		}

		private void menuItemSortRegion_Click(object sender, System.EventArgs e)
		{
			if (!IsCustomersTableShown(true))
				return;

			this.groupingGrid1.Engine.TableDescriptor.SortedColumns.Add("Region", ListSortDirection.Ascending);
		}

		private void menuItemSortCity_Click(object sender, System.EventArgs e)
		{
			if (!IsCustomersTableShown(true))
				return;

			this.groupingGrid1.Engine.TableDescriptor.SortedColumns.Add("City", ListSortDirection.Ascending);
		}

		private void menuItemSortSalesTitle_Click(object sender, System.EventArgs e)
		{
			if (!IsCustomersTableShown(true))
				return;

			this.groupingGrid1.Engine.TableDescriptor.SortedColumns.Add("ContactTitle", ListSortDirection.Ascending);
		}

		private void menuItemSortPostal_Click(object sender, System.EventArgs e)
		{
			if (!IsCustomersTableShown(true))
				return;

			this.groupingGrid1.Engine.TableDescriptor.SortedColumns.Add("PostalCode", ListSortDirection.Ascending);
		}

		private void menuItemSortClear_Click(object sender, System.EventArgs e)
		{
			this.groupingGrid1.Engine.TableDescriptor.ResetSortedColumns();
		}

		private void menuItemNavNextRec_Click(object sender, System.EventArgs e)
		{
			GridTable table = this.groupingGrid1.Engine.Table;
			FilteredRecordsInTableCollection filteredRecords = table.FilteredRecords;
			int index = filteredRecords.IndexOf(table.CurrentRecord);
			if (index != -1 && index + 1 < filteredRecords.Count)
			{
				Record r = filteredRecords[index+1];
				table.CurrentRecord = r;
			}
		}

		private void menuItemNavPrevRec_Click(object sender, System.EventArgs e)
		{
			GridTable table = this.groupingGrid1.Engine.Table;
			FilteredRecordsInTableCollection filteredRecords = table.FilteredRecords;
			int index = filteredRecords.IndexOf(table.CurrentRecord);
			if (index != -1 && index > 0)
				table.CurrentRecord = filteredRecords[index-1];
		}

		private void menuItemResetColumns_Click(object sender, System.EventArgs e)
		{
			this.groupingGrid1.Engine.TableDescriptor.ResetColumns();
		}

		OleDbConnection connection;
		string fileName = "";

		private void menuItemBrowseTable_Click(object sender, System.EventArgs e)
		{
			SelectTableForm f = new SelectTableForm();
			f.Table = this.groupingGrid1.Engine.DataMember;
			if (fileName != "")
			{
				f.FileName = fileName;
				f.Table = this.groupingGrid1.Engine.DataMember;
			}
			if (f.ShowDialog() == DialogResult.OK && f.Table != "")
			{
				fileName = f.FileName;
				OleDbDataAdapter dataAdapter = null;
				DataSet _dataSet = null;
				string tableName = f.Table;

				try
				{
					// Connection object
					if (connection == null)
						connection = new OleDbConnection(f.ConnectionString);

					// Create data adapter object
					dataAdapter = new OleDbDataAdapter("SELECT * FROM [" + tableName + "]", connection);
			
					// Create a dataset object and fill with data using data adapter's Fill method
					_dataSet = new DataSet();
					dataAdapter.Fill(_dataSet, tableName);
					connection.Close();

					this.groupingGrid1.CancelEdit();
					if (f.ResetColumnChecked || f.Table != this.groupingGrid1.Engine.DataMember)
					{
						this.groupingGrid1.ResetTableDescriptor();
					}

					this.groupingGrid1.Engine.DataMember = "";
					this.groupingGrid1.Engine.DataSource = _dataSet.Tables[tableName];

					this.Text = tableName;
				}
				catch(Exception ex)
				{	
					MessageBox.Show("Problem with DB access-\n\n   connection: "
						+ f.ConnectionString + "\n\n" + ex.ToString());
					return;
				}
			}
		}

		GroupingGridPropertyDialog frm;
		private void Form1_Load(object sender, System.EventArgs e)
		{
			frm = new GroupingGridPropertyDialog(this.groupingGrid1);
			Point pt = new Point(this.Right, this.Top);
			frm.Show();
			frm.Bounds = new Rectangle(pt, new Size(350, this.Height));
		}

		private void menuItemDisplayStyles_Click(object sender, System.EventArgs e)
		{
			_ShowGridBaseStylesDialog(this.groupingGrid1.Engine, "BaseStyles", null, typeof(GridTableBaseStyleCollection));
		}

		private void menuItemXPThemes_Click(object sender, System.EventArgs e)
		{
			GridStyleInfo standard = this.groupingGrid1.Engine.Appearance.AnyCell;
			standard.Themed = !standard.Themed;
			this.groupingGrid1.ThemesEnabled = standard.Themed;
		}

		private void menuItemCustomers_Click(object sender, System.EventArgs e)
		{
			this.groupingGrid1.ResetTableDescriptor();
			this.groupingGrid1.DataSource = this.dataSet11;//.Customers;
			this.groupingGrid1.DataMember = "";
		}

		private void menuItem10_Click(object sender, System.EventArgs e)
		{
			this.groupingGrid1.ResetTableDescriptor();		
		}

		private void menuItemChooseColumnSets_Click(object sender, System.EventArgs e)
		{
			_ShowGridColumnsDialog(this.groupingGrid1.Engine.TableDescriptor, "ColumnSets", null, typeof(GridColumnSetDescriptorCollection));
		}

		private void menuItemResetColumnSets_Click(object sender, System.EventArgs e)
		{
			this.groupingGrid1.Engine.TableDescriptor.ResetColumnSets();
		}

		private void menuItemChooseColumnOrder_Click(object sender, System.EventArgs e)
		{
			_ShowGridColumnsDialog(this.groupingGrid1.Engine.TableDescriptor, "VisibleColumns", null, typeof(GridVisibleColumnDescriptorCollection));
		}

		private void menuItemResetColumnOrder_Click(object sender, System.EventArgs e)
		{
			this.groupingGrid1.Engine.TableDescriptor.VisibleColumns.Reset();
		}

		private void menuItemExpressionColumns_Click(object sender, System.EventArgs e)
		{
			_ShowGridColumnsDialog(this.groupingGrid1.Engine.TableDescriptor, "ExpressionFields", null, typeof(ExpressionFieldDescriptorCollection));
		}

		private void groupingGrid1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			e.Style.CellTipText = e.TableCellIdentity.Info;
		}

		private void Model_QueryRowHeight(object sender, GridRowColSizeEventArgs e)
		{
		}
	}
}